<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2019
 *
 * Generated from xml/schema/CRM/Contact/RelateEntities.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:ebfcea88ae4bd09a0821a942ecdfa4db)
 */

/**
 * Database access object for the RelateEntities entity.
 */
class CRM_RelateEntities_DAO_RelateEntities extends CRM_Core_DAO {

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_relate_entities';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * RelateEntities ID
   *
   * @var int
   */
  public $id;
  public $entity_table_a;
  public $entity_table_b;
  public $entity_id_a;
  public $entity_id_b;
  public $relationship_type_id;
  public $created_date;
  public $modified_date;
  public $is_active;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_relate_entities';
    parent::__construct();
  }

  /**
   * Returns foreign keys and entity references.
   *
   * @return array
   *   [CRM_Core_Reference_Interface]
   */
  public static function getReferenceColumns() {
    if (!isset(Civi::$statics[__CLASS__]['links'])) {
      Civi::$statics[__CLASS__]['links'] = static::createReferenceColumns(__CLASS__);
      Civi::$statics[__CLASS__]['links'][] = new CRM_Core_Reference_Basic(self::getTableName(), 'relationship_type_id', 'civicrm_relationship_type', 'id');
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'links_callback', Civi::$statics[__CLASS__]['links']);
    }
    return Civi::$statics[__CLASS__]['links'];
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('RelateEntities ID'),
          'description' => ts('RelateEntities ID'),
          'required' => TRUE,
          'where' => 'civicrm_relate_entities.id',
          'table_name' => 'civicrm_relate_entities',
          'entity' => 'RelateEntities',
          'bao' => 'CRM_RelateEntities_BAO_RelateEntities',
          'localizable' => 0,
        ],
        'entity_table_a' => [
          'name' => 'entity_table_a',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => ts('Entity Table A'),
          'description' => ts('May contain civicrm_financial_item, civicrm_contribution, civicrm_financial_trxn, civicrm_grant, etc'),
          'required' => TRUE,
          'maxlength' => 64,
          'size' => CRM_Utils_Type::BIG,
          'import' => TRUE,
          'export' => TRUE,
          'table_name' => 'civicrm_relate_entities',
          'entity' => 'RelateEntities',
          'bao' => 'CRM_RelateEntities_DAO_RelateEntities',
          'localizable' => 0,
        ],
        'entity_table_b' => [
          'name' => 'entity_table_b',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => ts('Entity Table B'),
          'description' => ts('May contain civicrm_financial_item, civicrm_contribution, civicrm_financial_trxn, civicrm_grant, etc'),
          'required' => TRUE,
          'maxlength' => 64,
          'size' => CRM_Utils_Type::BIG,
          'import' => TRUE,
          'export' => TRUE,
          'table_name' => 'civicrm_relate_entities',
          'entity' => 'RelateEntities',
          'bao' => 'CRM_RelateEntities_DAO_RelateEntities',
          'localizable' => 0,
        ],
        'entity_id_a' => [
          'name' => 'entity_id_a',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Entity Id A'),
          'description' => '',
          'required' => TRUE,
          'table_name' => 'civicrm_relate_entities',
          'entity' => 'RelateEntities',
          'bao' => 'CRM_RelateEntities_BAO_RelateEntities',
          'localizable' => 0,
        ],
        'entity_id_b' => [
          'name' => 'entity_id_b',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Entity Id B'),
          'description' => '',
          'required' => TRUE,
          'table_name' => 'civicrm_relate_entities',
          'entity' => 'RelateEntities',
          'bao' => 'CRM_RelateEntities_BAO_RelateEntities',
          'localizable' => 0,
        ],
        'relationship_type_id' => [
          'name' => 'relationship_type_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Relationship Type'),
          'description' => ts('id of the relationship'),
          'required' => TRUE,
          'table_name' => 'civicrm_relate_entities',
          'entity' => 'RelateEntities',
          'bao' => 'CRM_RelateEntities_BAO_RelateEntities',
          'localizable' => 0,
          'FKClassName' => 'CRM_Relationship_DAO_RelationshipType',
          'html' => [
            'type' => 'Select',
          ],
        ],
        'created_date' => [
          'name' => 'created_date',
          'type' => CRM_Utils_Type::T_DATE,
          'title' => ts('RelateEntities Created Date'),
          'description' => ts('date when the relationship created'),
          'table_name' => 'civicrm_relate_entities',
          'entity' => 'RelateEntities',
          'bao' => 'CRM_RelateEntities_BAO_RelateEntities',
          'localizable' => 0,
          'html' => [
            'type' => 'Select Date',
            'formatType' => 'activityDate',
          ],
        ],
        'modified_date' => [
          'name' => 'modified_date',
          'type' => CRM_Utils_Type::T_DATE,
          'title' => ts('RelateEntities Modified Date'),
          'description' => ts('date when the relationship modified'),
          'table_name' => 'civicrm_relate_entities',
          'entity' => 'RelateEntities',
          'bao' => 'CRM_RelateEntities_BAO_RelateEntities',
          'localizable' => 0,
          'html' => [
            'type' => 'Select Date',
            'formatType' => 'activityDate',
          ],
        ],
        'is_active' => [
          'name' => 'is_active',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => ts('Is Active?'),
          'description' => ts('is active ?'),
          'default' => '1',
          'table_name' => 'civicrm_relate_entities',
          'entity' => 'RelateEntities',
          'bao' => 'CRM_RelateEntities_BAO_RelateEntities',
          'localizable' => 0,
          'html' => [
            'type' => 'Radio',
          ],
          'options' => [
            '1' => ts('Yes'),
            '0' => ts('No'),
          ],
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Return a mapping from field-name to the corresponding key (as used in fields()).
   *
   * @return array
   *   Array(string $name => string $uniqueName).
   */
  public static function &fieldKeys() {
    if (!isset(Civi::$statics[__CLASS__]['fieldKeys'])) {
      Civi::$statics[__CLASS__]['fieldKeys'] = array_flip(CRM_Utils_Array::collect('name', self::fields()));
    }
    return Civi::$statics[__CLASS__]['fieldKeys'];
  }

  /**
   * Returns the names of this table
   *
   * @return string
   */
  public static function getTableName() {
    return self::$_tableName;
  }

  /**
   * Returns if this table needs to be logged
   *
   * @return bool
   */
  public function getLog() {
    return self::$_log;
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'relate_entities', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'relate_entities', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
